(function() {
    var PuperGrep = require("./index"),
        puper     = new PuperGrep(),
        manager   = puper.getLogReaderManager();

    manager.addLog("pew", "/tmp/pew", function() {
        console.log("Added log pew", arguments);
    });

    manager.addLog("PretenderFast", "/tmp/Pretender", function() {
        console.log("Added log Pretender", arguments);
    });

    require("fs").readdir("/tmp/scribe", function(error, dirs) {
        if (error) {
            console.log(error);
            return;
        }

        dirs.forEach(function(dir) {
            manager.addLog(dir, "/tmp/scribe/" + dir + "/" + dir + "_current", function() {
                console.log("Added log " + dir, arguments);
            });
        });
    });

    puper.listen(8080, "127.0.0.1");


    return;

    var LogReaderManager = require("./lib/LogReaderManager"),
        fs               = require("fs"),
        path             = require("path"),
        io               = require("socket.io").listen(8080, "127.0.0.1"),
        manager;

    manager = new LogReaderManager();

    fs.readdir("/var/log", function(error, files) {
        files.forEach(function(file) {
            manager.addLog(file, path.join("/var/log", file), function() {
                console.log(arguments);
            });
        });
    });

    manager.addLog("pew", "/tmp/pew", function() {
        console.log("Added log pew", arguments);
    });

    manager.addLog("Pretender", "/tmp/Pretender", function() {
        console.log("Added log pew", arguments);
    });



    io.sockets.on("connection", function(socket) {
        var lastLog = {
            name     : undefined,
            listener : undefined
        };

        function unsubscribeFromPreviousLog(callback) {
            if (!lastLog.name) {
                return callback();
            }

            manager.getLogReader(lastLog.name, function(error, reader) {
                if (error) {
                    return callback(error);
                }

                reader.removeListener("line", lastLog.listener);

                lastLog.name     = undefined;
                lastLog.listener = undefined;

                if (reader.listeners("line").length == 0) {
                    reader.detach();
                    return callback(undefined, true);
                }

                return callback(undefined, false);
            });
        }

        console.log("Got socket.io connection!");

        socket.emit("logs", {
            logs: manager.getLogsNames().sort()
        });

        socket.on("subscribe", function(data) {
            console.log("Got subscription: ", data);
            unsubscribeFromPreviousLog(function(error) {
                console.log(arguments);
                if (error) {
                    console.log(error);
                    return;
                }

                manager.getLogReader(data.name, function(error, reader) {
                    console.log(arguments);
                    if (error) {
                        console.log(error);
                        return;
                    }

                    function listener(line) {
                        socket.emit("line", {
                            line: line
                        });
                    }

                    reader.getBuffer().forEach(listener);
                    reader.on("line", listener);
                    reader.attach();

                    console.log("attached!");

                    lastLog.name     = data.name;
                    lastLog.listener = listener;
                });
            });
        });

        socket.on("disconnect", function() {
            unsubscribeFromPreviousLog(function(error) {
                if (error) {
                    console.log(error);
                }
            });
        });
    });


})();
